TEMPLATE = app
TARGET = necroplayer2
DEPENDPATH += . src
INCLUDEPATH += . src

VERSION = 0.1.0

DEFINES += VERSION=\\\"$$VERSION\\\"

QT += dbus
QT += maemo5
QT += phonon

OBJECTS_DIR = build/
MOC_DIR = build/

# Input
HEADERS +=  src/Engine.h \
    src/Player.h \
    src/UI.h \
    src/UIPlaylist.h \
    src/UILibrary.h \
    src/UIControl.h \
    src/Config.h \
    src/SettingsDialog.h \
    src/UrlDialog.h \
    src/UIControl2.h \
    src/UIControl3.h \
    src/CoverDialog.h \
    src/DelegatePlaylist.h \
    src/DelegateFolder.h \
    src/DBusService.h \
    src/SimpleView.h \
    src/SimpleViewFM.h

SOURCES +=  src/Engine.cpp \
    src/main.cpp \
    src/Player.cpp \
    src/UI.cpp \
    src/UIPlaylist.cpp \
    src/UILibrary.cpp \
    src/UIControl.cpp \
    src/Config.cpp \
    src/SettingsDialog.cpp \
    src/UrlDialog.cpp \
    src/UIControl2.cpp \
    src/UIControl3.cpp \
    src/CoverDialog.cpp \
    src/DelegatePlaylist.cpp \
    src/DelegateFolder.cpp \
    src/DBusService.cpp \
    src/SimpleView.cpp \
    src/SimpleViewFM.cpp

TRANSLATIONS = translations/necroplayer2_de.ts \
               translations/necroplayer2_ru.ts

CODECFORSRC = UTF-8

unix {
    INSTALLS += target desktop launch service lang icon48 icon64 icons32 icons40 icons64 icons295 images
    target.path = /opt/necroplayer2/bin
    desktop.path = /usr/share/applications/hildon
    desktop.files += maemo5/necroplayer2.desktop
    launch.path = /usr/bin
    launch.files += scripts/necroplayer2
    service.path = /usr/share/dbus-1/services
    service.files += dbus/org.maemo.necroplayer2.service
    lang.path = /opt/necroplayer2/translations
    lang.files += translations/necroplayer2_de.qm
    icon48.path = /usr/share/icons/hicolor/48x48/apps
    icon48.files += maemo5/48x48/necroplayer2.png
    icon64.path = /usr/share/icons/hicolor/64x64/apps
    icon64.files += maemo5/64x64/necroplayer2.png
    icons32.path = /opt/necroplayer2/icons/32x32
    icons32.files += icons/32x32/arrow_up.png
    icons32.files += icons/32x32/arrow_down.png
    icons32.files += icons/32x32/delete.png
    icons32.files += icons/32x32/volume.png
    icons32.files += icons/32x32/muted.png
    icons32.files += icons/32x32/back.png
    icons32.files += icons/32x32/add.png
    icons32.files += icons/32x32/replace.png
    icons32.files += icons/32x32/autoaddons.png
    icons32.files += icons/32x32/noautoaddons.png
    icons32.files += icons/32x32/folders.png
    icons40.path = /opt/necroplayer2/icons/40x40
    icons40.files += icons/40x40/fm_transmitter.png
    icons64.path = /opt/necroplayer2/icons/64x64
    icons64.files += icons/64x64/play.png
    icons64.files += icons/64x64/pause.png
    icons64.files += icons/64x64/stop.png
    icons64.files += icons/64x64/next.png
    icons64.files += icons/64x64/previous.png
    icons64.files += icons/64x64/fmfreq_down.png
    icons64.files += icons/64x64/fmfreq_up.png
    icons295.path = /opt/necroplayer2/icons/295x295
    icons295.files += icons/295x295/default_album.png
    icons295.files += icons/295x295/default_stream.png
    images.path = /opt/necroplayer2/images
    images.files += images/background.png
    images.files += images/simpleviewfm_back.png
}

OTHER_FILES += \
    qtc_packaging/debian_fremantle/rules \
    qtc_packaging/debian_fremantle/README \
    qtc_packaging/debian_fremantle/copyright \
    qtc_packaging/debian_fremantle/control \
    qtc_packaging/debian_fremantle/compat \
    qtc_packaging/debian_fremantle/changelog \
    qtc_packaging/debian_fremantle/rules \
    qtc_packaging/debian_fremantle/README \
    qtc_packaging/debian_fremantle/copyright \
    qtc_packaging/debian_fremantle/control \
    qtc_packaging/debian_fremantle/compat \
    qtc_packaging/debian_fremantle/changelog
